import{s as Ne,n as Re,o as Ke}from"../chunks/scheduler.048ce5c2.js";import{S as Be,i as Qe,g as a,s as n,r as j,A as Ye,h as l,f as i,c as s,j as Ge,u as z,x as r,k as ye,y as Ze,a as o,v as U,d as W,t as E,w as F}from"../chunks/index.2633050f.js";import{H as G}from"../chunks/Heading.bb054f8c.js";function Ve(_e){let f,K,N,B,h,Q,u,xe=`Welcome to Unit 1 of the Hugging Face Diffusion Models Course! In this unit, you will learn the basics of how diffusion
models work and how to create your own using the 🤗 Diffusers library.`,Y,m,Z,g,ke="Here are the steps for this unit:",V,c,$e='<li>Make sure you’ve <a href="https://huggingface.us17.list-manage.com/subscribe?u=7f57e683fa28b51bfc493d048&amp;id=ef963b4162" rel="nofollow">signed up for this course</a> so that you can be notified when new material is released.</li> <li>Read through the introductory material below as well as any of the additional resources that sound interesting.</li> <li>Check out the <em><strong>Introduction to Diffusers</strong></em>  notebook below to put theory into practice with the 🤗 Diffusers library.</li> <li>Train and share your own diffusion model using the notebook or the linked training script.</li> <li>(Optional) Dive deeper with the <em><strong>Diffusion Models from Scratch</strong></em> notebook if you’re interested in seeing a minimal from-scratch implementation and exploring the different design decisions involved.</li> <li>(Optional) Check out <a href="https://www.youtube.com/watch?v=09o5cv6u76c" rel="nofollow">this video</a> for an informal run-through the material for this unit.</li>',J,p,Te=':loudspeaker: Don’t forget to join the <a href="https://huggingface.co/join/discord" rel="nofollow">Discord</a>, where you can discuss the material and share what you’ve made in the <code>#diffusion-models-class</code> channel.',X,w,ee,b,Ce="Diffusion models are a relatively recent addition to a group of algorithms known as ‘generative models’. The goal of generative modeling is to learn to <strong>generate</strong> data, such as images or audio, given a number of training examples. A good generative model will create a <strong>diverse</strong> set of outputs that resemble the training data without being exact copies. How do diffusion models achieve this? Let’s focus on the image generation case for illustrative purposes.",te,d,Me='<img src="https://user-images.githubusercontent.com/10695622/174349667-04e9e485-793b-429a-affe-096e8199ad5b.png" width="800"/> <br/> <em>Figure from DDPM paper (https://arxiv.org/abs/2006.11239).</em> ',v,He="",y,Le="The secret to diffusion models’ success is the iterative nature of the diffusion process. Generation begins with random noise, but this is gradually refined over a number of steps until an output image emerges. At each step, the model estimates how we could go from the current input to a completely denoised version. However, since we only make a small change at every step, any errors in this estimate at the early stages (where predicting the final output is extremely difficult) can be corrected in later updates.",ie,_,Pe=`Training the model is relatively straightforward compared to some other types of generative model. We repeatedly
1) Load in some images from the training data
2) Add noise, in different amounts. Remember, we want the model to do a good job estimating how to ‘fix’ (denoise) both extremely noisy images and images that are close to perfect.
3) Feed the noisy versions of the inputs into the model
4) Evaluate how well the model does at denoising these inputs
5) Use this information to update the model weights`,oe,x,De="To generate new images with a trained model, we begin with a completely random input and repeatedly feed it through the model, updating it each time by a small amount based on the model prediction. As we’ll see, there are a number of sampling methods that try to streamline this process so that we can generate good images with as few steps as possible.",ne,k,Ae="We will show each of these steps in detail in the hands-on notebooks here in unit 1. In unit 2, we will look at how this process can be modified to add additional control over the model outputs through extra conditioning (such as a class label) or with techniques such as guidance. And units 3 and 4 will explore an extremely powerful diffusion model called Stable Diffusion, which can generate images given text descriptions.",se,$,ae,T,Ie="At this point, you know enough to get started with the accompanying notebooks! The two notebooks here come at the same idea in different ways.",le,C,Se='<thead><tr><th align="left">Chapter</th> <th align="left">Colab</th> <th align="left">Kaggle</th> <th align="left">Gradient</th> <th align="left">Studio Lab</th></tr></thead> <tbody><tr><td align="left">Introduction to Diffusers</td> <td align="left"><a href="https://colab.research.google.com/github/huggingface/diffusion-models-class/blob/main/unit1/01_introduction_to_diffusers.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td> <td align="left"><a href="https://kaggle.com/kernels/welcome?src=https://github.com/huggingface/diffusion-models-class/blob/main/unit1/01_introduction_to_diffusers.ipynb" rel="nofollow"><img src="https://kaggle.com/static/images/open-in-kaggle.svg" alt="Kaggle"/></a></td> <td align="left"><a href="https://console.paperspace.com/github/huggingface/diffusion-models-class/blob/main/unit1/01_introduction_to_diffusers.ipynb" rel="nofollow"><img src="https://assets.paperspace.io/img/gradient-badge.svg" alt="Gradient"/></a></td> <td align="left"><a href="https://studiolab.sagemaker.aws/import/github/huggingface/diffusion-models-class/blob/main/unit1/01_introduction_to_diffusers.ipynb" rel="nofollow"><img src="https://studiolab.sagemaker.aws/studiolab.svg" alt="Open In SageMaker Studio Lab"/></a></td></tr> <tr><td align="left">Diffusion Models from Scratch</td> <td align="left"><a href="https://colab.research.google.com/github/huggingface/diffusion-models-class/blob/main/unit1/02_diffusion_models_from_scratch.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a></td> <td align="left"><a href="https://kaggle.com/kernels/welcome?src=https://github.com/huggingface/diffusion-models-class/blob/main/unit1/02_diffusion_models_from_scratch.ipynb" rel="nofollow"><img src="https://kaggle.com/static/images/open-in-kaggle.svg" alt="Kaggle"/></a></td> <td align="left"><a href="https://console.paperspace.com/github/huggingface/diffusion-models-class/blob/main/unit1/02_diffusion_models_from_scratch.ipynb" rel="nofollow"><img src="https://assets.paperspace.io/img/gradient-badge.svg" alt="Gradient"/></a></td> <td align="left"><a href="https://studiolab.sagemaker.aws/import/github/huggingface/diffusion-models-class/blob/main/unit1/02_diffusion_models_from_scratch.ipynb" rel="nofollow"><img src="https://studiolab.sagemaker.aws/studiolab.svg" alt="Open In SageMaker Studio Lab"/></a></td></tr></tbody>',re,M,qe="In <em><strong>Introduction to Diffusers</strong></em>, we show the different steps described above using building blocks from the diffusers library. You’ll quickly see how to create, train and sample your own diffusion models on whatever data you choose. By the end of the notebook, you’ll be able to read and modify the example training script to train diffusion models and share them with the world! This notebook also introduces the main exercise associated with this unit, where we will collectively attempt to figure out good ‘training recipes’ for diffusion models at different scales - see the next section for more info.",fe,H,Oe="In <em><strong>Diffusion Models from Scratch</strong></em>, we show those same steps (adding noise to data, creating a model, training and sampling) but implemented from scratch in PyTorch as simply as possible. Then we compare this ‘toy example’ with the diffusers version, noting how the two differ and where improvements have been made. The goal here is to gain familiarity with the different components and the design decisions that go into them so that when you look at a new implementation you can quickly identify the key ideas.",de,L,he,P,je="Now that you’ve got the basics down, have a go at training one or more diffusion models! Some suggestions are included at the end of the <em><strong>Introduction to Diffusers</strong></em> notebook. Make sure to share your results, training recipes and findings with the community so that we can collectively figure out the best ways to train these models.",ue,D,me,A,ze=`<a href="https://huggingface.co/blog/annotated-diffusion" rel="nofollow">The Annotated Diffusion Model</a> is a very in-depth walk-through of the code and theory behind DDPMs with
maths and code showing all the different components. It also links to a number of papers for further reading.`,ge,I,Ue='Hugging Face documentation on <a href="https://huggingface.co/docs/diffusers/training/unconditional_training" rel="nofollow">Unconditional Image-Generation</a> for some examples of how to train diffusion models using the official training example script, including code showing how to create your own dataset.',ce,S,We='AI Coffee Break video on Diffusion Models: <a href="https://www.youtube.com/watch?v=344w5h24-h8" rel="nofollow">https://www.youtube.com/watch?v=344w5h24-h8</a>',pe,q,Ee='Yannic Kilcher Video on DDPMs: <a href="https://www.youtube.com/watch?v=W-O7AZNzbzQ" rel="nofollow">https://www.youtube.com/watch?v=W-O7AZNzbzQ</a>',we,O,Fe="Found more great resources? Let us know and we’ll add them to this list.",be,R,ve;return h=new G({props:{title:"Unit 1: An Introduction to Diffusion Models",local:"unit-1-an-introduction-to-diffusion-models",headingTag:"h1"}}),m=new G({props:{title:"Start this Unit :rocket:",local:"start-this-unit-rocket",headingTag:"h2"}}),w=new G({props:{title:"What Are Diffusion Models?",local:"what-are-diffusion-models",headingTag:"h2"}}),$=new G({props:{title:"Hands-On Notebooks",local:"hands-on-notebooks",headingTag:"h2"}}),L=new G({props:{title:"Project Time",local:"project-time",headingTag:"h2"}}),D=new G({props:{title:"Some Additional Resources",local:"some-additional-resources",headingTag:"h2"}}),{c(){f=a("meta"),K=n(),N=a("p"),B=n(),j(h.$$.fragment),Q=n(),u=a("p"),u.textContent=xe,Y=n(),j(m.$$.fragment),Z=n(),g=a("p"),g.textContent=ke,V=n(),c=a("ul"),c.innerHTML=$e,J=n(),p=a("p"),p.innerHTML=Te,X=n(),j(w.$$.fragment),ee=n(),b=a("p"),b.innerHTML=Ce,te=n(),d=a("p"),d.innerHTML=Me,v=a("p"),v.innerHTML=He,y=a("p"),y.textContent=Le,ie=n(),_=a("p"),_.textContent=Pe,oe=n(),x=a("p"),x.textContent=De,ne=n(),k=a("p"),k.textContent=Ae,se=n(),j($.$$.fragment),ae=n(),T=a("p"),T.textContent=Ie,le=n(),C=a("table"),C.innerHTML=Se,re=n(),M=a("p"),M.innerHTML=qe,fe=n(),H=a("p"),H.innerHTML=Oe,de=n(),j(L.$$.fragment),he=n(),P=a("p"),P.innerHTML=je,ue=n(),j(D.$$.fragment),me=n(),A=a("p"),A.innerHTML=ze,ge=n(),I=a("p"),I.innerHTML=Ue,ce=n(),S=a("p"),S.innerHTML=We,pe=n(),q=a("p"),q.innerHTML=Ee,we=n(),O=a("p"),O.textContent=Fe,be=n(),R=a("p"),this.h()},l(e){const t=Ye("svelte-u9bgzb",document.head);f=l(t,"META",{name:!0,content:!0}),t.forEach(i),K=s(e),N=l(e,"P",{}),Ge(N).forEach(i),B=s(e),z(h.$$.fragment,e),Q=s(e),u=l(e,"P",{"data-svelte-h":!0}),r(u)!=="svelte-1bkeb93"&&(u.textContent=xe),Y=s(e),z(m.$$.fragment,e),Z=s(e),g=l(e,"P",{"data-svelte-h":!0}),r(g)!=="svelte-1hcxnu9"&&(g.textContent=ke),V=s(e),c=l(e,"UL",{"data-svelte-h":!0}),r(c)!=="svelte-1chf7fu"&&(c.innerHTML=$e),J=s(e),p=l(e,"P",{"data-svelte-h":!0}),r(p)!=="svelte-1ppoip6"&&(p.innerHTML=Te),X=s(e),z(w.$$.fragment,e),ee=s(e),b=l(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-xyibvp"&&(b.innerHTML=Ce),te=s(e),d=l(e,"P",{align:!0,"data-svelte-h":!0}),r(d)!=="svelte-zzx38x"&&(d.innerHTML=Me),v=l(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-b5f4e5"&&(v.innerHTML=He),y=l(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-4ja3ad"&&(y.textContent=Le),ie=s(e),_=l(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-19n5l9g"&&(_.textContent=Pe),oe=s(e),x=l(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-11xgppe"&&(x.textContent=De),ne=s(e),k=l(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-v7qqiy"&&(k.textContent=Ae),se=s(e),z($.$$.fragment,e),ae=s(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-mzqiq8"&&(T.textContent=Ie),le=s(e),C=l(e,"TABLE",{"data-svelte-h":!0}),r(C)!=="svelte-7mysoe"&&(C.innerHTML=Se),re=s(e),M=l(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-14qrqf4"&&(M.innerHTML=qe),fe=s(e),H=l(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-149sgh3"&&(H.innerHTML=Oe),de=s(e),z(L.$$.fragment,e),he=s(e),P=l(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-u0rdns"&&(P.innerHTML=je),ue=s(e),z(D.$$.fragment,e),me=s(e),A=l(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-t200gn"&&(A.innerHTML=ze),ge=s(e),I=l(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-d84ssd"&&(I.innerHTML=Ue),ce=s(e),S=l(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-2rmkz1"&&(S.innerHTML=We),pe=s(e),q=l(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-12yr97d"&&(q.innerHTML=Ee),we=s(e),O=l(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1wvf2ag"&&(O.textContent=Fe),be=s(e),R=l(e,"P",{}),Ge(R).forEach(i),this.h()},h(){ye(f,"name","hf:doc:metadata"),ye(f,"content",Je),ye(d,"align","center")},m(e,t){Ze(document.head,f),o(e,K,t),o(e,N,t),o(e,B,t),U(h,e,t),o(e,Q,t),o(e,u,t),o(e,Y,t),U(m,e,t),o(e,Z,t),o(e,g,t),o(e,V,t),o(e,c,t),o(e,J,t),o(e,p,t),o(e,X,t),U(w,e,t),o(e,ee,t),o(e,b,t),o(e,te,t),o(e,d,t),o(e,v,t),o(e,y,t),o(e,ie,t),o(e,_,t),o(e,oe,t),o(e,x,t),o(e,ne,t),o(e,k,t),o(e,se,t),U($,e,t),o(e,ae,t),o(e,T,t),o(e,le,t),o(e,C,t),o(e,re,t),o(e,M,t),o(e,fe,t),o(e,H,t),o(e,de,t),U(L,e,t),o(e,he,t),o(e,P,t),o(e,ue,t),U(D,e,t),o(e,me,t),o(e,A,t),o(e,ge,t),o(e,I,t),o(e,ce,t),o(e,S,t),o(e,pe,t),o(e,q,t),o(e,we,t),o(e,O,t),o(e,be,t),o(e,R,t),ve=!0},p:Re,i(e){ve||(W(h.$$.fragment,e),W(m.$$.fragment,e),W(w.$$.fragment,e),W($.$$.fragment,e),W(L.$$.fragment,e),W(D.$$.fragment,e),ve=!0)},o(e){E(h.$$.fragment,e),E(m.$$.fragment,e),E(w.$$.fragment,e),E($.$$.fragment,e),E(L.$$.fragment,e),E(D.$$.fragment,e),ve=!1},d(e){e&&(i(K),i(N),i(B),i(Q),i(u),i(Y),i(Z),i(g),i(V),i(c),i(J),i(p),i(X),i(ee),i(b),i(te),i(d),i(v),i(y),i(ie),i(_),i(oe),i(x),i(ne),i(k),i(se),i(ae),i(T),i(le),i(C),i(re),i(M),i(fe),i(H),i(de),i(he),i(P),i(ue),i(me),i(A),i(ge),i(I),i(ce),i(S),i(pe),i(q),i(we),i(O),i(be),i(R)),i(f),F(h,e),F(m,e),F(w,e),F($,e),F(L,e),F(D,e)}}}const Je='{"title":"Unit 1: An Introduction to Diffusion Models","local":"unit-1-an-introduction-to-diffusion-models","sections":[{"title":"Start this Unit :rocket:","local":"start-this-unit-rocket","sections":[],"depth":2},{"title":"What Are Diffusion Models?","local":"what-are-diffusion-models","sections":[],"depth":2},{"title":"Hands-On Notebooks","local":"hands-on-notebooks","sections":[],"depth":2},{"title":"Project Time","local":"project-time","sections":[],"depth":2},{"title":"Some Additional Resources","local":"some-additional-resources","sections":[],"depth":2}],"depth":1}';function Xe(_e){return Ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ot extends Be{constructor(f){super(),Qe(this,f,Xe,Ve,Ne,{})}}export{ot as component};
